package de.uks.plm.ftglb.incremental.bcg;

import x10.compiler.*;

import de.uks.plm.ftglb.incremental.TaskBag;

public final class Bag implements TaskBag
{
    public var lower:Rail[Int];
    public var upper:Rail[Int];

    public def this(size:Long)
    {
        lower = new Rail[Int](size);
        upper = new Rail[Int](size);
    }

    @Inline public def size() : Long
    {
        return (this.lower.size);
    }

    @Inline public def merge(val that:TaskBag) : void
    {
        this.merge(that as Bag);
    }

    @Inline public def merge(that:Bag) : void
    {
        val thisSize:Long = this.size();
        if (0 == thisSize)
        {
            this.lower = that.lower;
            this.upper = that.upper;
            return;
        }

        val thatSize:Long = that.size();
        if ((null == that) || (0 == thatSize))
        {
            return;
        }

        val newSize:Long = thisSize + thatSize;
        val newLower:Rail[Int] = new Rail[Int](newSize);
        val newUpper:Rail[Int] = new Rail[Int](newSize);

        Rail.copy(this.lower, 0, newLower, 0, thisSize);
        Rail.copy(that.lower, 0, newLower, thisSize, thatSize);

        Rail.copy(this.upper, 0, newUpper, 0, thisSize);
        Rail.copy(that.upper, 0, newUpper, thisSize, thatSize);

        this.lower = newLower;
        this.upper = newUpper;
    }
}
