package de.uks.plm.ftglb.incremental.utsg;

import x10.compiler.*;

import de.uks.plm.ftglb.incremental.TaskBag;

public final class Bag implements TaskBag {
    public var hash:Rail[SHA1Rand];
    public var lower:Rail[Int];
    public var upper:Rail[Int];
    
    public def this(size:Long) {
        hash = new Rail[SHA1Rand](size);
        lower = new Rail[Int](size);
        upper = new Rail[Int](size);
    }

    @Inline public def merge(val bag:TaskBag) : void {
        this.merge(bag as Bag);
    }

    @Inline public def merge(val that:Bag) : void {
        val h = that.size();
        val q = this.size();
        val n = h + q;
        val hash:Rail[SHA1Rand] = new Rail[SHA1Rand](n);
        val lower:Rail[Int] = new Rail[Int](n);
        val upper:Rail[Int] = new Rail[Int](n);
        Rail.copy(this.hash, 0, hash, 0, q);
        Rail.copy(this.lower, 0, upper, 0, q);
        Rail.copy(this.lower, 0, upper, 0, q);
        Rail.copy(that.hash, 0, hash, q, h);
        Rail.copy(that.lower, 0, upper, q, h);
        Rail.copy(that.lower, 0, upper, q, h);
        this.hash = hash;
        this.lower = lower;
        this.upper = upper;
    }

    @Inline public def size() = hash.size;
}
