package de.uks.plm.ftglb.incremental.utsg;

import x10.compiler.*;

import x10.util.Team;
import de.uks.plm.ftglb.incremental.GLBResult;
import de.uks.plm.ftglb.incremental.TaskQueue;
import de.uks.plm.ftglb.incremental.TaskBag;

public final class Queue extends UTS implements TaskQueue[Queue, Long] {
	public def this(factor:Int) {
		super(factor);
	}
	
	@Inline public def process(n:Long) {
		var i:Long=0;
		for (; (i<n) && (size>0); ++i) {
			expand();
		}
		count += i;
		return size > 0;
	}
	
	@Inline public def split() {
		var s:Long = 0;
		for (var i:Long=0; i<size; ++i) {
			if ((upper(i) - lower(i)) >= 2) ++s;
		}
		if (s == 0) return null;
		val bag = new Bag(s);
		s = 0;
		for (var i:Long=0; i<size; ++i) {
			val p = upper(i) - lower(i);
			if (p >= 2n) {
				bag.hash(s) = hash(i);
				bag.upper(s) = upper(i);
				upper(i) -= p/2n;
				bag.lower(s++) = upper(i);
			}
		}
		return bag;
	}
	
	@Inline public def merge(bag:Bag) : void
	{
		merge(bag.hash, bag.lower, bag.upper);
	}

    @Inline public def merge(that:Queue) :void
    {
        merge(that.hash, that.lower, that.upper);
    }

    @Inline public def merge(val hash:Rail[SHA1Rand]
                             , val lower:Rail[Int]
                             , val upper:Rail[Int]) : void
    {
        val h:Long = hash.size;
        val q = this.size;
        while (h + q > this.hash.size) grow();
        Rail.copy(hash, 0, this.hash, q, h);
        Rail.copy(lower, 0, this.lower, q, h);
        Rail.copy(upper, 0, this.upper, q, h);
        this.size += h;
    }
	
	@Inline public def merge(bag:TaskBag) {
		merge(bag as Bag);
	}
	
	// override
	public def printLog(){
		
	}
	
	@Inline public def count() = count;
	
	var result:UTSResult = null;
	public def getResult(): UTSResult {
		val result = new UTSResult();
		return result;
	}

    @Inline public def mergeResult(val that:TaskQueue[Queue, Long]) : void
    {
        assert (that instanceof Queue) // Always false.
                :  here + ": in mergeResult(val that:TaskQueue[Queue, Long]): "
                 + "Parameter is not of type Queue!";
    }

    @Inline public def mergeResult(val that:Queue) : void
    {
        count += that.count;
    }

	public class UTSResult extends GLBResult[Long]{
		r:Rail[Long] = new Rail[Long](1l);		
		public  def getResult(): Rail[Long]{
			r(0) = count;
			return r;
		}
		public  def getReduceOperator():Int{
			return Team.ADD;
		}
		
		public def display(r:Rail[Long]):void{
			Console.OUT.println("Myresult: "+r(0));
		}
	}
		
	
	
	
	
	
}
