package de.uks.plm.utils;

public class SimpleQueue[T] {T haszero}
{
    private var zero:T;

    var head:Node[T];
    var tail:Node[T];
    var size:Long;

    public def this()
    {
        this.head = null;
        this.tail = null;
        this.size = 0;
    }

    public def push(val t:T)
    {
        val node:Node[T] = new Node[T](t);
        this.tail.setNext(node);
        node.setPrev(this.tail);
        this.tail = this.tail.next();
        ++this.size;
    }

    public def isEmpty() : Boolean
    {
        return (null != this.head);
    }

    public def pop() : T
    {
        assert (!this.isEmpty())
                : here + ": cannot pop something from an empty queue!";

        --this.size;
        val res:T = this.head.get();
        this.head = this.head.next();
        if (0 == this.size)
        {
            this.head = null;
            this.tail = null;
        }
        return (res);
    }

    public def size() : Long
    {
        return (this.size);
    }

    static class Node[T]
    {
        private var data:T;
        private var next:Node[T];
        private var prev:Node[T];

        public def this(val t:T)
        {
            this(t, null, null);
        }

        public def this(val data:T, val next:Node[T], val prev:Node[T])
        {
            this.data = data;
            this.next = next;
            this.prev = prev;
        }

        public def get() : T
        {
            return (this.data);
        }

        public def next() : Node[T]
        {
            return (this.next);
        }

        public def prev() : Node[T]
        {
            return (this.prev);
        }

        public def setNext(val next:Node[T]) : void
        {
            this.next = next;
        }

        public def setPrev(val prev:Node[T]) : void
        {
            this.prev = prev;
        }
    }
}